<template>
  <div class="search-section" :class="{ desktop: !isMobileGlobal() }">
    <div class="section-header" v-if="isMobileGlobal()">
      <a-row class="input-search">
        <a-icon type="search"></a-icon>
        <a-input class="input-search" @pressEnter="handleEnterSearch"></a-input>
      </a-row>
      <span class="cancel-btn" @click="goBack">Cancel</span>
    </div>
    <div>
      <a-row class="result-container" v-if="isShowResultSection">
        <div class="song-list" v-show="dataSearch.songs.length">
          <h2 class="sub-title">Tracks</h2>
          <a-row :gutter="12">
            <a-col
              class="gutter-row"
              :xs="{ span: 12 }"
              :sm="{ span: 12 }"
              :md="{ span: 8 }"
              :lg="{ span: 6 }"
              :xxl="{ span: 4 }"
              v-for="(item, ind) in dataSearch.songs"
              :key="ind"
            >
              <div class="category">
                <div class="background" @click="playMusic(item.song_file, item.name, item.artist_name, item.thumb)">
                  <div class="wrap-image square wrap-btn-gl">
                    <img :src="item.img_thumb || item.img_banner" />
                    <span class="btn-play-gl">
                      <a-icon type="caret-right" />
                    </span>
                  </div>
                  <h3 class="title">{{ item.name }}</h3>
                  <div class="description">{{ item.description || item.content }}</div>
                </div>
              </div>
            </a-col>
          </a-row>
        </div>
      </a-row>
      <a-row v-else class="section-search">
        <a-col :xs="{ span: 24 }" :sm="{ span: 24 }" :md="{ span: 24 }" :lg="{ span: 24 }">
          <p class="title-text">Search for grafsound</p>
        </a-col>
        <a-col :xs="{ span: 24 }" :sm="{ span: 24 }" :md="{ span: 24 }" :lg="{ span: 24 }">
          <span class="content-text">
            Tìm kiếm các bài hát, nghệ sĩ, Albums, và playlist yêu thích của bạn
          </span>
        </a-col>
      </a-row>
    </div>
  </div>
</template>

<script>
import service from "../service.js";

export default {
  data() {
    return {
      dataSearch: {
        songs: [],
        artists: [],
        playlists: []
      },
      querySearch: null
    };
  },
  computed: {
    isShowResultSection() {
      if (this.dataSearch.songs.length || this.dataSearch.artists.length || this.dataSearch.playlists.length) {
        return true;
      }
    }
  },
  watch: {
    "$route.query"(newValue) {
      if (newValue.query && newValue.query !== this.querySearch) {
        this.querySearch = newValue.query;
        this.callApiSearch(newValue.query);
      }
    }
  },
  methods: {
    goBack() {
      this.$router.back();
    },
    handleEnterSearch(event) {
      let value = event.target.value;

      if (!value) return;

      this.$router.push(`/search/?query=${value}`);
    },
    async callApiSearch(query) {
      let res = await service.get("/search/search", { params: { query } });
      let data = res && res.data && res.data.code === 200 ? res.data.data : { artists: [], songs: [], playlists: [] };
      let { artists, songs, playlists } = data;

      this.dataSearch = { songs, artists, playlists };
    },
    playMusic(url, title, artist, photo) {
      this.$store.dispatch("player/playMusic", {
        url,
        title,
        artist,
        photo
      });
    }
  },
  mounted() {
    let query = this.$route.query && this.$route.query.query ? this.$route.query.query : null;

    if (query) {
      this.querySearch = query;
      this.callApiSearch(query);
    }
  }
};
</script>

<style scoped>
.search-section {
  background: #121212;
  padding-top: 70px;
  position: absolute;
  width: 100%;
  height: 100vh;
  top: -70px;
  z-index: 99;
}
.section-header {
  width: 100%;
  font-size: 1rem;
  padding: 15px 5%;
  display: flex;
  align-items: center;
}
.section-header .input-search {
  width: 100%;
  margin-right: 8px;
}
.section-header .input-search input {
  height: 30px;
  background: #6a6a6a !important;
  border-radius: 10px !important;
  border: none;
  padding-left: 30px;
}
.section-header .input-search i {
  position: absolute;
  font-size: 20px;
  z-index: 1;
  left: 8px;
  top: 50%;
  transform: translateY(-50%);
}
.section-search {
  margin: 0;
  padding: 20px;
  width: 100%;
}
.section-search .title-text {
  font-weight: 500;
  font-size: 18px;
  text-align: center;
  letter-spacing: -0.24px;
  color: #f1f1f1;
  margin-bottom: 4px;
}
.section-search .content-text {
  font-weight: 300;
  font-size: 14px;
  text-align: center;
  letter-spacing: -0.24px;
  color: #f1f1f1;
}
.result-container {
  padding: 0 32px;
}
.result-container .sub-title,
.result-container .title,
.result-container .description {
  text-align: left;
}

/* Desktop Style */
.search-section.desktop {
  padding-top: 32px;
  position: relative;
  height: 100%;
  top: unset;
}
.desktop .section-search {
  padding-top: 62px;
}
</style>
